--- ../sendmail-8.13.8-orig/sendmail/srvrsmtp.c	2006-07-07 12:29:39.000000000 -0400
+++ ././sendmail/srvrsmtp.c	2006-11-09 08:08:20.000000000 -0500
@@ -3698,12 +3715,14 @@
 		unsigned int shift;
 		time_t s;
 
+#if !_FFR_ATTACK_LOG_SLEEP
 		if (*pcounter == maxcount && LogLevel > 5)
 		{
 			sm_syslog(LOG_INFO, e->e_id,
 				  "%s: possible SMTP attack: command=%.40s, count=%u",
 				  CurSmtpClient, cname, *pcounter);
 		}
+#endif /*!_FFR_ATTACK_LOG_SLEEP */
 		shift = *pcounter - maxcount;
 		s = 1 << shift;
 		if (shift > MAXSHIFT || s >= MAXTIMEOUT || s <= 0)
@@ -3717,6 +3736,15 @@
 		s -= *pcounter / maxcount;
 		if (s >= MAXTIMEOUT || s < 0)
 			s = MAXTIMEOUT;
+#if _FFR_ATTACK_LOG_SLEEP
+		if (*pcounter >= maxcount && LogLevel > 5)
+		{
+			sm_syslog(LOG_INFO, e->e_id,
+				  "%s: possible SMTP attack: command=%.40s, count=%u, sleeptime=%d, return=%d",
+				  CurSmtpClient, cname, *pcounter, ((waitnow) ? s : 0 ) + (*pcounter / maxcount),
+				  (waitnow) ? IS_ATTACK(0) : IS_ATTACK(s));
+		}
+#endif /*_FFR_ATTACK_LOG_SLEEP */
 		if (waitnow && s > 0)
 		{
 			(void) sleep(s);
